using System;
using System.Data.SqlClient;
using Microsoft.Win32;

namespace C
{
	/// <summary>
	/// Summary description for DataServices.
	/// </summary>
	public class DataServices
	{
	    private SqlConnection m_cn = new SqlConnection();

	public DataServices()
	{
	    //Todo - set the connection string for your server
        const string CONNECTION_STRING 
          = "data source=????????\\VSDOTNET;"  
            + "initial catalog=dbWebLex;"  
               + "integrated security=SSPI;"  
                + "persist security info=False;"  
                  + "workstation id=????????;"  
                    + "packet size=4096";

        string strConnectionString 
          = GetSetting(System.Windows.Forms.Application.ProductName, "Connection", "String", "????????");
		char[] c = {'?'};
        if (strConnectionString.IndexOfAny(c) >= 0) 
		{
			frmInputBox f = new frmInputBox();
            strConnectionString = f.InputBox("Connection string?", "Connection String", strConnectionString);
            if (strConnectionString != "")
                SaveSetting(System.Windows.Forms.Application.ProductName, "Connection", "String", strConnectionString);
		}
		try
		{
			m_cn.ConnectionString = strConnectionString;
			m_cn.Open();
		}
        catch
		{
            System.Windows.Forms.MessageBox.Show("Connection string appears to be invalid");
            SaveSetting(System.Windows.Forms.Application.ProductName, "Connection", "String", CONNECTION_STRING);
		}
	}

	public void Dispose()
	{
		m_cn.Close();
	}

	public bool Connected
	{
		get
		{
			return m_cn.State == System.Data.ConnectionState.Open;
		}
	}

	public bool WasIndexed(string URL, DateTime ContentDate)
	{
        SqlCommand cmd = new SqlCommand("WasIndexed", m_cn);
        cmd.CommandType = System.Data.CommandType.StoredProcedure;
        cmd.Parameters.Add("@URL", URL);
        cmd.Parameters.Add("@ContentDate", ContentDate);
		return((bool) cmd.ExecuteScalar());
	}

		public void IndexContent(string strTitle, string strURL, string strContent)
		{
        const int MAX_WORDS_LENGTH = 8000;
        bool bReplaceURL = true;
        if (strContent.Length < MAX_WORDS_LENGTH)
            IndexWords(strTitle, strURL, strContent, bReplaceURL);
        else
		{
            //Bigger than MAX_WORDS_LENGTH, break it up.
            long s;
            do
			{
				System.Text.RegularExpressions.Regex r
					= new System.Text.RegularExpressions.Regex(" "
					,System.Text.RegularExpressions.RegexOptions.RightToLeft);
				System.Text.RegularExpressions.Match m 
					= r.Match(strContent);
				s = m.Index;
				if (s == 0)
				{
					s = strContent.Length + 1;
					if (s > MAX_WORDS_LENGTH)
						//We have an 8000 byte word here - skip it
						break;
					
				}
				IndexWords(strTitle, strURL, Left(strContent, (int) s - 1), bReplaceURL);
				bReplaceURL = false;
				strContent = strContent.Substring((int) (s + 1));
			}
			while (strContent == "");
			}

			IndexWords(strTitle, strURL, strContent, bReplaceURL);
			}

		private bool IndexWords(string strTitle, string strURL, string strContent, bool bReplaceURL)
		{
			try
			{
				strContent = StripSpecialCharacters(strContent);
				SqlCommand cmd = new SqlCommand("Addwords", m_cn);
				cmd.CommandType = System.Data.CommandType.StoredProcedure;
				cmd.Parameters.Add("@Title", strTitle);
				cmd.Parameters.Add("@URL", strURL);
				cmd.Parameters.Add("@Words", strContent);
				cmd.Parameters.Add("@ReplaceURL", bReplaceURL);
				cmd.ExecuteNonQuery();
				return(true);
			}
			catch
			{
				return(false);
			}
		}

		private string Left(string strString, int intLength)
		{
			if (strString.Length < intLength)
				return(strString);
			else
				return(strString.Substring(0, intLength));
		}

		public string GetSetting(string AppName, string Section, string Key, string Default)
		{
			RegistryKey rkVBASettings 
				= Registry.CurrentUser.OpenSubKey(@"Software\VB and VBA Program Settings\" + 
				AppName + "\\" + Section);
			string strResult = Default;
			if(rkVBASettings != null)
				strResult = (string)rkVBASettings.GetValue(Key);
			return(strResult);
		}

		public void SaveSetting(string AppName, string Section, string Key, string Setting)
		{
			// Los datos se guardan en:
			// HKEY_CURRENT_USER\Software\VB and VBA Program Settings
			RegistryKey rk 
				= Registry.CurrentUser.CreateSubKey(@"Software\VB and VBA Program Settings\" + 
				AppName + "\\" + Section);
			rk.SetValue(Key, Setting); 
		}

		private string StripSpecialCharacters(string strContent)
		{
			string[] strTreatAsBlank = {"\t", "\n", "\r", "&", @"\*", @"\+", ",", ";", "-", @"\.", "/", "{", "}", @"\|", "~", "<", ">", ":", "=", "_"};
			string[] strTreatAsNull = {"!", @"""", "#", @"\$", "%", "'", @"\(", @"\)", @"\[", @"\]", @"\?", "@", "","^"};
			int i = 0;

			//Treat as blank characters to blank
			for (i = 0; i < strTreatAsBlank.Length; i++)
				strContent = System.Text.RegularExpressions.Regex.Replace(strContent, strTreatAsBlank[i], " ");

			//Treat as null characters to null
			for (i = 0; i < strTreatAsNull.Length; i++)
				strContent = System.Text.RegularExpressions.Regex.Replace(strContent, strTreatAsNull[i], "");

			return strContent;
		}

	}
}
