'WebLex: A Web Indexing Program
'
'Jon Vote - 2004
'
'Idioma Software Inc. 
'www.idioma-software.com
'www.skycoder.com 
'jon@idioma-software.com 
'
'541-488-1972 (USA)

Imports System.Data.SqlClient
Friend Class DataServices

    Private m_cn As New SqlConnection()
    Public ReadOnly Property Connected() As Boolean
        Get
            Connected = m_cn.State = ConnectionState.Open
        End Get
    End Property

    Public Sub New()
        'Todo - set the connection string for your server
        Const CONNECTION_STRING As String _
          = "data source=????????\VSDOTNET;" _
            & "initial catalog=dbWebLex;" _
                 & "integrated security=SSPI;" _
                  & "persist security info=False;" _
                   & "workstation id=????????;" _
                    & "packet size=4096"
        Dim strConnectionString As String _
          = GetSetting(Application.ProductName, "Connection", "String", "????????")

        If strConnectionString.IndexOfAny("?") >= 0 Then
            strConnectionString = InputBox("Connection string?", "Connection String", strConnectionString)
            If strConnectionString <> "" Then
                SaveSetting(Application.ProductName, "Connection", "String", strConnectionString)
            End If
        End If
        Try
            m_cn.ConnectionString = strConnectionString
            m_cn.Open()
        Catch
            MsgBox("Connection string appears to be invalid")
            SaveSetting(Application.ProductName, "Connection", "String", CONNECTION_STRING)
        End Try
    End Sub

    Public Function WasIndexed(ByVal URL As String, ByVal ContentDate As DateTime) As Boolean
        Dim cmd As New SqlCommand("WasIndexed", m_cn)
        cmd.CommandType = CommandType.StoredProcedure
        cmd.Parameters.Add("@URL", URL)
        cmd.Parameters.Add("@ContentDate", ContentDate)
        WasIndexed = CType(cmd.ExecuteScalar, Boolean)
    End Function

    Protected Overrides Sub Finalize()
        m_cn.Close()
        MyBase.Finalize()
    End Sub

    Public Sub IndexContent(ByVal strTitle As String, ByVal strURL As String, ByVal strContent As String)

        Const MAX_WORDS_LENGTH = 8000
        Dim bReplaceURL As Boolean = True
        If Len(strContent) < MAX_WORDS_LENGTH Then
            IndexWords(strTitle, strURL, strContent, bReplaceURL)
        Else
            'Bigger than MAX_WORDS_LENGTH, break it up.
            Dim s As Long
            Do
                s = InStrRev(strContent, " ", MAX_WORDS_LENGTH)
                If s = 0 Then
                    s = Len(strContent) + 1
                    If s > MAX_WORDS_LENGTH Then
                        'We have an 8000 byte word here - skip it
                        Exit Sub
                    End If
                End If
                IndexWords(strTitle, strURL, Left$(strContent, s - 1), bReplaceURL)
                bReplaceURL = False
                strContent = Mid$(strContent, s + 1)
            Loop Until strContent = ""
        End If

        IndexWords(strTitle, strURL, strContent, bReplaceURL)
    End Sub

    Private Function IndexWords(ByVal strTitle As String, ByVal strURL As String, ByVal strContent As String, ByVal bReplaceURL As Boolean) As Boolean

        Try
            strContent = StripSpecialCharacters(strContent)
            Dim cmd As New SqlCommand("Addwords", m_cn)
            cmd.CommandType = CommandType.StoredProcedure
            cmd.Parameters.Add("@Title", strTitle)
            cmd.Parameters.Add("@URL", strURL)
            cmd.Parameters.Add("@Words", strContent)
            cmd.Parameters.Add("@ReplaceURL", bReplaceURL)
            cmd.ExecuteNonQuery()
            IndexWords = True
        Catch
            IndexWords = False
        End Try
    End Function

    Private Function StripSpecialCharacters(ByVal strContent As String) As String
        Dim strTreatAsBlank() As String = {Chr(9), Chr(10), Chr(13), "&", "*", "+", ",", ";", "-", ".", "/", "{", "}", "|", "~", "<", ">", ":", "=", "_"}
        Dim strTreatAsNull() As String = {"!", """", "#", "$", "%", "'", "(", ")", "[", "]", "?", "@", "", "^"}
        Dim i As Long

        'Treat as blank characters to blank
        For i = 0 To UBound(strTreatAsBlank)
            strContent = Replace(strContent, strTreatAsBlank(i), " ")
        Next i

        'Treat as null characters to null
        For i = 0 To UBound(strTreatAsNull)
            strContent = Replace(strContent, strTreatAsNull(i), "")
        Next i
        StripSpecialCharacters = strContent
    End Function

End Class
